{***********************************************************************}
{*                       Vitus Graphic interfasce                      *}
{*                             Version 1.0                             *}
{*                 Copyright (C) by V.B.Wagner  , 1991                 *}
{*                              VGILo.Pas                              *}
{*           楤 ࠡ  ࠭  ன           *}
{*                       ᪮ ०                           *}
{***********************************************************************}
Unit VGILo;
interface
uses graph;
Function SaveGraphWindow(X1,Y1,X2,Y2:integer;var p:pointer):boolean;
{࠭  ᪮  ᮤন .(न ᪨)
 頥 True, ᫨  㤠  False  砥 墠⪨ }

Procedure RestoreGraphWindow(X1,y1:word;var p:Pointer;Deallocate:boolean);
{⠭ , ࠭ SaveGraphWindow.᫨ Deallocate=True,
 ᢮ }

Function SaveGraphSettings(var Save:pointer):boolean;

Procedure RestoreGraphSettings(Save:pointer;Deallocate:boolean);

Function LoadFont(Filename:string):integer;

procedure DisposeFont;

procedure GrWrite(s:String;row,col,attr:byte);

Function ReadKeyWord:Word;inline($B8/$00/$00/$cd/$16);

Function KeyPressed:Boolean ; inline
($B4/$01         {MOV	AH,01}
/$CD/$16         {INT	16H}
/$74/$04         {JZ	NoKey}
/$B0/$01         {MOV	AL,True}
/$EB/$02         {JMP	Exit}
/$B0/$00); {NoKey:MOV	AL,00}
            {Exit:}

implementation
uses BgiInst;
const FontPtr:Pointer=nil;
var FontSize:word;


Function SaveGraphWindow(X1,Y1,X2,Y2:integer;var p:pointer):boolean;
var size:word;
begin
 Size:=ImageSize(X1,Y1,X2,Y2);
 if(Size=0)or(Size>MaxAvail) then
   begin
    SaveGraphWindow:=False;
    exit
   end;
 GetMem(p,Size);
 GetImage(X1,Y1,X2,Y2,p^);
 SaveGraphWindow:=True
end;
Procedure RestoreGraphWindow(X1,y1:word;var p:Pointer;Deallocate:boolean);
type tt=record x,y:word end;
var Size:Word;
    q:^tt;
begin
 Putimage(X1,Y1,p^,CopyPut);
 If Deallocate then
  begin
   q:=p;
   Size:=ImageSize(1,1,q^.x,q^.y);
   FreeMem(p,Size);
  end;
end;
procedure GrWrite(s:String;row,col,attr:byte);
var x,i:integer;
var top,bottom:integer;
begin
 SetFillStyle(SolidFill,(Attr and $F0)shr 4);
 SetTextJustify(LeftText,BottomText);
 x:=(GetMaxX+1) div 80*(col-1);
 Top:=GraphStringHeight*(row-1);
 Bottom:=GraphStringHeight*row;
 Bar(x,Top,x+TextWidth(s),Bottom);
 SetColor(Attr and $F);
 For i:=1 to ord(s[0]) do if s[i]=#0 then s[i]:=' ';
 OutTextXY(x,Bottom,s)
end;
Function SaveGraphSettings(var Save:pointer):boolean;
const SaveSize=33;
var s,o,i:word;
    t:TextSettingsType;
    l:LineSettingsType;
    f:FillSettingsType;
    V:ViewPortType;
begin
 if MaxAvail<SaveSize then begin SaveGraphSettings:=false;exit end;
 GetMem(Save,SaveSize);
 s:=Seg(Save^);
 o:=ofs(Save^);
 i:=getcolor;
 MemW[s:o]:=getcolor;
 MemW[s:o+2]:=GetBkColor;
 GetViewSettings(v);
 Move(v,Mem[s:o+4],sizeOf(v));
 GetTextSettings(t);
 Move(t,Mem[s:o+13],sizeOf(t));
 GetLineSettings(l);
 Move(l,Mem[s:o+23],sizeOf(l));
 GetFillSettings(f);
 Move(f,Mem[s:o+29],sizeOf(f));
 SaveGraphSettings:=True
end;
Procedure RestoreGraphSettings(Save:pointer;Deallocate:boolean);
type SaveType=Record
           Color,Bkcolor:word;
           x1,y1,x2,y2:word;clip:boolean;
           Font,Dir,Size,Horiz,Vert:word;
           lstyle,lpat,lthick:word;
           fpat,fcolor:word
          end;
var p:^SaveType;
begin
 p:=Save;
 With p^ do
  begin
   SetColor(color);
   SetBkColor(BkColor);
   SetViewPort(x1,y1,x2,y2,clip);
   SetTextStyle(Font,Dir,Size);
   SetTextJustify(Horiz,Vert);
   SetLineStyle(Lstyle,lpat,lthick);
   SetFillStyle(fpat,fcolor);
  end;
  if Deallocate then dispose(p);
end;
Function LoadFont(Filename:string):integer;
var f:file;

begin
assign(f,filename);
{$I-}
reset(f,1);
{$i+}
if IOresult<>0 then
 begin
  LoadFont:=-3;
  exit
 end;
FontSize:=FileSize(f);
Getmem(FontPtr,FontSize);
BlockRead(f,FontPtr^,FontSize);
LoadFont:=RegisterBGIFont(FontPtr);
end;
procedure DisposeFont;
begin
if FontPtr=nil then exit;
 FreeMem(FontPtr,FontSize);
 FontPtr:=nil;
end;

end.